routes/web.php
<?php

use App\Http\Controllers\ActivityController;
use App\Http\Controllers\BrandController;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\ClientController;
use App\Http\Controllers\FileController;
use App\Http\Controllers\WebsiteController;
use App\Http\Controllers\ImageController;
use App\Http\Controllers\ProductController;
use App\Http\Controllers\ProjectController;
use App\Http\Controllers\SentenceController;
use App\Http\Controllers\SubActivityController;
use App\Http\Controllers\TicketController;
use App\Http\Controllers\UserController;
use App\Models\Brand;
use App\Models\Image;
use App\Models\Product;
use App\Models\SubActivity;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Mail;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return redirect('/home');
    $ar = [
        'Hello' => 'HelloX',
        'Yes' => 'YesX'
    ];
    unset($ar['Hello']);
    dd($ar);
    //send email for user contain link of new passord
    Mail::send('mail_test', array('body' => 'Test Email'),
    function ($message) {
        $message->to('eng.yousha.asaad@gmail.com');
        $message->subject('Test');
    });


     //get base sentences (in english) from languages file to transalte it
     $source = require resource_path('lang/ar/sentence.php');
     //we store translations here

     //fill temp array with all english sentences and make its translations = ' '
     foreach ($source as $key => $value) {
         $temp[$key] = '';
     }

    /*
    $prodcuts = Brand::find(1);
    dd($prodcuts->images[0]->path);
    */
    /*
    $image = new Image();
    $image->path = 'assets/images/brancd/wavetec2.png';

    $prodcuts = Brand::find(1);
    $prodcuts->images()->save($image);
    dd($prodcuts);
    */
    return view('welcome');
});

//website toutes
Route::get('/home', [WebsiteController::class , 'index']);
Route::get('/services', [WebsiteController::class , 'showServices'])->name('showService');

//panel routes
Route::resource('brand' , BrandController::class);
Route::resource('category' , CategoryController::class);
Route::resource('product' , ProductController::class);
Route::resource('image' , ImageController::class);
Route::resource('project' , ProjectController::class);
Route::resource('activity' , ActivityController::class);
Route::resource('sub-activity' , SubActivityController::class);
Route::resource('ticket' , TicketController::class);
Route::resource('file' , FileController::class);
Route::resource('user' , UserController::class);
Route::resource('client' , ClientController::class);
Route::resource('sentence' , SentenceController::class);

Route::post('/delete_brands', [BrandController::class , 'deleteGroup'])->name('delete_brands');
Route::post('/delete_clients', [ClientController::class , 'deleteGroup'])->name('delete_clients');
Route::post('/delete_categories', [CategoryController::class , 'deleteGroup'])->name('delete_categories');
Route::post('/delete_products', [ProductController::class , 'deleteGroup'])->name('delete_products');
Route::get('{brand_id}/categories' , [BrandController::class , 'showCategories'])->name('showCategories');
Route::post('/delete_activities', [ActivityController::class , 'deleteGroup'])->name('delete_activities');
Route::post('/delete_sub_activities', [SubActivityController::class , 'deleteGroup'])->name('delete_sub_activities');
Route::post('/delete_files', [FileController::class , 'deleteGroup'])->name('delete_files');
Route::get('/downloads/{type}', [FileController::class , 'show_downloads'])->name('downloads');
Route::post('/verify_all_users', [UserController::class , 'verifyGroup'])->name('verify_all_users');

Route::post('/resolve_tickets', [TicketController::class , 'resolve_all_tickets'])->name('resolve_tickets');

Auth::routes();

Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');


//General setting

Route::get('/general', [App\Http\Controllers\GeneralSetting::class, 'index'])->name('general_setting');
Route::get('/updated_ticekts_time', [App\Http\Controllers\GeneralSetting::class, 'update_times'])->name('update_times');
Route::get('/change_language', [App\Http\Controllers\GeneralSetting::class, 'change_language'])->name('change_language');

app/Models/SubActivity.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\DB;

class SubActivity extends Model implements Operations
{
    use HasFactory;
    public $fillable = ['sub_activity_name' , 'description' , 'activity_id'];
    public $timestamps = false;


    public function activity(){
        return $this->belongsTo(Activity::class);
    }

    public function images(){
        return $this->morphMany(Image::class , 'imageable');
    }



        //operation
        public static function getAll(){
            return SubActivity::all();
        }

        public static function  getById($id){
            return SubActivity::find($id);
        }

        public static function getByColumn($column , $value){
            return DB::table('sub_activities')->where($column , $value)->get();
        }

        public static function insert_data($data){
            return DB::table('sub_activities')->insert($data);
        }

        public static function update_data($id , $data){
           return  DB::table('sub_activities')->where('id' , $id)->update($data);
        }
        public static function delete_data($id){
            return DB::table('sub_activities')->where('id' , $id)->delete();
        }

        public static function getSubActivitiesForActivity($activity_id)
        {
            return SubActivity::where('activity_id' , $activity_id)->get();
        }
}

app/Http/Controllers/SubActivityController.php
<?php

namespace App\Http\Controllers;

use App\Models\Activity;
use App\Models\Image;
use App\Models\SubActivity;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\App;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\File;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Session;
use Illuminate\Support\Facades\Validator;

class SubActivityController extends Controller
{

    public static $images_path =  '/assets/images/sub_activity/';
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        App::setLocale(Session::get('lang'));
        return view('pages.sub_activity.index')->withSubactivities(SubActivity::getAll())->withactivities(Activity::getAll());
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $validator = Validator::make($request->all() , [
            'sub_activity_name' => 'required|max:40',
            'description' => 'required',
            'activity_id' => 'required',
            'images' => 'required'
        ]);

        if($validator->fails())
        {
           Session::flash('fail' , "Try Again");
           return redirect()->back();
        }else
        {
           DB::beginTransaction();

           try{
               $new_sub_activity = SubActivity::create([
                'sub_activity_name' => $request->sub_activity_name,
                'description' => $request->description,
                'activity_id' => $request->activity_id
               ]);

               if($new_sub_activity != null)
               {
                   //add images for this activity
                   foreach($request->file('images') as $image)
                   {
                       $random_image_name = uniqid().'.'.$image->clientExtension();
                       $image->move(public_path(self::$images_path), $random_image_name);

                       //add image for Images table
                       $image_data = new Image();
                       $image_data->path = env('APP_URL').self::$images_path.$random_image_name;

                       $new_sub_activity->images()->save($image_data);
                   }

                   //add brand data to translation file
                  storeSetneceInLanguageFile([$request->sub_activity_name , $request->description]);

                   DB::commit();
                   Session::flash('success' , 'Done Successfully');
               }
           }catch(\Exception $ex)
           {
               DB::rollBack();
               Log::info('Error in add Sub Sub ACtivity');
               Log::info($ex->getMessage());
           }

           return redirect()->back();
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\SubActivity  $sub_acticity
     * @return \Illuminate\Http\Response
     */
    public function show(SubActivity $sub_acticity)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\SubActivity  $sub_acticity
     * @return \Illuminate\Http\Response
     */
    public function edit(SubActivity $sub_acticity)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\SubActivity  $subActivity
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, SubActivity $subActivity)
    {

        $validator = Validator::make($request->all() , [
            'sub_activity_name' => 'required|max:40',
            'description' => 'required',
            'activity_id' => 'required',
        ]);

        if($validator->fails())
        {
           Session::flash('fail' , "Try Again");
           return redirect()->back();
        }else
        {
           DB::beginTransaction();

           try{
                //chnage sentecnes in language file
              replaceSetneceInLanguageFile([
                $subActivity->sub_activity_name => $request->sub_activity_name,
                $subActivity->description => $request->description,
               ]);

               //changeable
               $updated_sub_activity = SubActivity::update_data($subActivity->id ,[
                'sub_activity_name' => $request->sub_activity_name,
                'description' => $request->description,
                'activity_id' => $request->activity_id,
               ]);
                   //add images for this sub activity
                   //here user might not add any extra image
                   if($request->file('images') != null )
                   {

                        foreach($request->file('images') as $image)
                        {
                            $random_image_name = uniqid().'.'.$image->clientExtension();
                            $image->move(public_path(self::$images_path), $random_image_name);

                            //add image for Images table
                            $image_data = new Image();
                            $image_data->path = env('APP_URL').self::$images_path.$random_image_name;

                            $subActivity->images()->save($image_data);
                        }
                   }


               DB::commit();
               Session::flash('success' , 'Done Successfully');
           }catch(\Exception $ex)
           {
               dd($ex->getMessage());
               DB::rollBack();
               Log::info('Error in update sub category');
               Log::info($ex->getMessage());
           }

           return redirect()->back();
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\SubActivity  $sub_acticity
     * @return \Illuminate\Http\Response
     */
    public function destroy(SubActivity $subActivity)
    {

        DB::beginTransaction();
        try{
            $data = [$subActivity->sub_activity_name , $subActivity->description];
           //here we will delete sub activity with its images

           //delete images
           foreach($subActivity->images as $image)
           {
               //get image name with extension then delete it from public folder
               $image_name = substr($image->path , strrpos($image->path , '/') +1);
               File::delete(public_path(self::$images_path.$image_name));
               $image->delete();
           }

           $subActivity->delete();
           deleteSetneceInLanguageFile($data);
           DB::commit();
           Session::flash('success' , 'Done Successfully');


        }catch(\Exception $ex)
        {
            Session::flash('fail' , "Try Again");
            DB::rollBack();
            Log::info($ex->getMessage());
        }
        return redirect()->back();
    }

    public function deleteGroup(Request $request)
    {
        DB::beginTransaction();

        try{

            unset($request['_token']);
            $deleted_categories_ids = array_values($request->all());

            foreach($deleted_categories_ids as $id)
            {
                //here we will delete sub activity with its images
                $sub_acticity = SubActivity::getById($id);

                //delete images
                foreach($sub_acticity->images as $image)
                {
                    //get image name with extension then delete it from public folder
                    $image_name = substr($image->path , strrpos($image->path , '/') +1);
                    File::delete(public_path(self::$images_path.$image_name));
                    $image->delete();
                }

                $sub_acticity->delete();
            }

            DB::commit();
            Session::flash('success' , 'Done Successfully');
        }catch(\Exception $ex)
        {
            Session::flash('fail' , "Try Again");
            DB::rollBack();
            Log::info($ex->getMessage());
        }

        return redirect()->back();
    }
}

resources/views/modals/sub_activity/addSubActivity.blade.php
<div id="addSubActivityModal" class="modal fade">
	<div class="modal-dialog">
		<div class="modal-content">
			<form method="POST"  action="{{route('sub-activity.store')}}"  enctype="multipart/form-data">
                @csrf
				<div class="modal-header">
					<h4 class="modal-title">Add Sub Activity</h4>
					<button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
				</div>
				<div class="modal-body">
					<div class="form-group">
						<label for="addSubActivityName">Sub Activity Name</label>
						<input id="addSubActivityName" type="text" class="form-control" name="sub_activity_name" maxlength="40" required>
					</div>

                     <div class="form-group">
                        <label for="addimge" class="form-label">Sub Activity image</label>
                        <input class="form-control form-control-md" name="images[]" multiple id="addimge" type="file" accept="image/*" required>
                      </div>

                      <div class="form-group">
                        <label for="addMainactivity" class="form-label">Main Activity Name</label>
                        <select class="form-select selectpicker"  name="activity_id"  id="addMainactivity"  required>
                            <option data-hidden="true" value="">
                                Select Main Activity
                            </option>
                            @foreach($activities as $activity)
                              <option value="{{$activity->id}}">{{$activity->activity_name}}</option>
                            @endforeach

                          </select>
                      </div>

					<div class="form-group">
						<label for="SubActivityDescription">Sub Activity Description</label>
						<textarea id="SubActivityDescription" class="form-control" name="description" required required></textarea>
					</div>
				</div>
				<div class="modal-footer">
					<input type="button" class="btn btn-info" data-dismiss="modal" value="Cancel">
					<input type="submit" class="btn btn-success" value="Add">
				</div>
			</form>
		</div>
	</div>
</div>

resources/views/modals/sub_activity/deleteSubActivity.blade.php
<div id="deleteEmployeeModal" class="modal fade">
	<div class="modal-dialog">
		<div class="modal-content">
			<form>
				<div class="modal-header">
					<h4 class="modal-title">Delete Employee</h4>
					<button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
				</div>
				<div class="modal-body">
					<p>Are you sure you want to delete these Records?</p>
					<p class="text-warning"><small>This action cannot be undone.</small></p>
				</div>
				<div class="modal-footer">
					<input type="button" class="btn btn-default" data-dismiss="modal" value="Cancel">
					<input type="submit" class="btn btn-danger" value="Delete">
				</div>
			</form>
		</div>
	</div>
</div>

resources/views/modals/sub_activity/editSubActivity.blade.php
<div id="editSubActivityModal" class="modal fade">
	<div class="modal-dialog">
		<div class="modal-content">
			<form method="POST"  enctype="multipart/form-data">
                @csrf
                @method('put')
				<div class="modal-header">
					<h4 class="modal-title">Edit Sub Activity</h4>
					<button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
				</div>
				<div class="modal-body">
					<div class="form-group">
						<label for="editSubActivityName">Sub Activity Name</label>
						<input id="editSubActivityName" type="text" class="form-control" name="sub_activity_name" maxlength="40" required>
					</div>

                     <div class="form-group">
                        <label for="editimge" class="form-label">Extra Sub Activity image</label>
                        <input class="form-control form-control-md" name="images[]" multiple id="editimge" type="file" accept="image/*">
                      </div>

                      <div class="form-group">
                        <label for="editMainActivity" class="form-label">Main Activity Name</label>
                        <select class="form-select selectpicker" id="editMainActivity"  name="activity_id" required>
                            <option data-hidden="true" value="">
                                Select Main Activity
                            </option>
                            @foreach($activities as $activity)
                              <option value="{{$activity->id}}">{{$activity->activity_name}}</option>
                            @endforeach
                          </select>
                      </div>

					<div class="form-group">
						<label for="editSubActivityDescription">Sub Activity Description</label>
						<textarea id="editSubActivityDescription" class="form-control" name="description" required required></textarea>
					</div>
				</div>
				<div class="modal-footer">
					<input type="button" class="btn btn-info" data-dismiss="modal" value="Cancel">
					<input type="submit" class="btn btn-success" value="Edit">
				</div>
			</form>
		</div>
	</div>
</div>